<?php

namespace  Onestartup\FacturaDigital\Lib;

class FacturaConceptoLista
{
    private $conceptos;
	
    /**
     * List of items.
     *
     * @param \PayPal\Api\Item[] $items
     * 
     * @return $this
     */
    public function setConceptos($conceptos)
    {
        $this->conceptos = $conceptos;
        return $this;
    }

    /**
     * List of items.
     *
     * @return \PayPal\Api\Item[]
     */
    public function getData()
    {
        return $this->conceptos;
    }

    /**
     * Append Items to the list.
     *
     * @param \PayPal\Api\Item $item
     * @return $this
     */
    public function addConcepto($concepto)
    {
        if (!$this->getConceptos()) {
            return $this->setConceptos(array($concepto));
        } else {
            return $this->setConceptos(
                array_merge($this->getConceptos(), array($concepto))
            );
        }
    }
	

}
